package pcc.chemicraft;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;
import net.minecraftforge.common.Property;
import net.minecraftforge.oredict.OreDictionary;
import pcc.chemicraft.block.BlockChemicalCombinationTable;
import pcc.chemicraft.block.BlockChemicalCraftingTable;
import pcc.chemicraft.block.BlockElectrolysisTable;
import pcc.chemicraft.block.BlockPyrolysisTable;
import pcc.chemicraft.block.BlockToolAndWeaponCraftingTable;
import pcc.chemicraft.compounds.CompoundDebug;
import pcc.chemicraft.compounds.CompoundWater;
import pcc.chemicraft.creativetab.CreativeTabAtomOres;
import pcc.chemicraft.creativetab.CreativeTabChemiCraft;
import pcc.chemicraft.debug.CommandDeleteItem;
import pcc.chemicraft.debug.CommandGenDebugRoom;
import pcc.chemicraft.debug.CommandSetTile;
import pcc.chemicraft.item.ItemAtoms;
import pcc.chemicraft.item.ItemAtomsGrenade;
import pcc.chemicraft.item.ItemChemiCell;
import pcc.chemicraft.item.ItemCompounds;
import pcc.chemicraft.item.ItemGasCollectingBottle;
import pcc.chemicraft.ore.BlockAtomOres;
import pcc.chemicraft.ore.ItemAtomOres;
import pcc.chemicraft.system.CommonProxy;
import pcc.chemicraft.system.PacketHandler;
import pcc.chemicraft.tileentity.TileEntityChemicalCombinationTable;
import pcc.chemicraft.tileentity.TileEntityChemicalCraftingTable;
import pcc.chemicraft.tileentity.TileEntityElectrolysisTable;
import pcc.chemicraft.tileentity.TileEntityPyrolysisTable;
import pcc.chemicraft.tileentity.TileEntityToolAndWeaponCraftingTable;
import pcc.chemicraft.util.Auxiliary;
import pcc.chemicraft.util.Auxiliary.ArrayAuxiliary;
import pcc.chemicraft.util.Auxiliary.NameAuxiliary;
import pcc.chemicraft.util.NBTRecipeGrenade;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
/**
 * ChemiCraft本体
 * @author P.C.C.
 *
 */
@Mod(modid = "chemiCraft", name = "ChemiCraft", version = "beta")
@NetworkMod(clientSideRequired = true, serverSideRequired = true, versionBounds = "1.4.6", channels = "chemicraft", packetHandler = PacketHandler.class)
public class ChemiCraft implements Runnable {

	public static final String[] ATOMSNAME = {
		"Hydrogen", "Helium", "Lithium", "Beryllium", "Boron", "Carbon", "Nitrogen", "Oxygen", "Fluorine", "Neon", "Sodium", "Magnesium", "Aluminium", "Silicon",
		"Phosphorus", "Sulfur", "Chlorine", "Argon", "Potassium", "Calcium", "Scandium", "Titanium", "Vanadium", "Chromium", "Manganese", "Iron", "Cobalt", "Nickel", "Copper", "Zinc", "Gallium",
		"Germanium", "Arsenic", "Selenium", "Bromine", "Krypton", "Rubidium", "Strontium", "Yttorium", "Zirconium", "Niobium", "Molybdenum", "Technetium", "Ruthenium", "Rhodium", "Palladium",
		"Silver", "Cadmium", "Indium", "Tin", "Antimony", "Tellurium", "Iodine", "Xenon", "Caesium", "Barium", "Lanthanum", "Cerium", "Praseodymium", "Neodymium", "Promethium", "Samarium",
		"Europium", "Gadolinium", "Terbium", "Dysprosium", "Holmium", "Erbium", "Thulium", "Ytterbium", "Lutetium", "Hafnium", "Tantalum", "Tungsten", "Rhenium", "Osmium", "Iridium", "Platinum",
		"Gold", "Mercury", "Thallium", "Lead", "Bismuth", "Polonium", "Astatine", "Radon", "Francium", "Radium", "Actinium", "Thorium", "Protactinium", "Uranium", "Neptunium", "Plutonium",
		"Americium", "Curium", "Berkelium", "Californium", "Einsteinium", "Fermium", "Mendelevium", "Nobelium", "Lawrencium", "Rutherfordium", "Dubnium", "Seaborgium", "Bohrium", "Hassium",
		"Meitnerium", "Darmstadtium", "Roentgenium", "Copernicium", "Ununtrium", "Ununquadium", "Ununpentium", "Ununhexium", "Ununseptium", "Ununoctium" };

	public static final String[] ATOMSNAMEJP = {
		"水素", "ヘリウム", "リチウム", "ベリウム", "ホウ素", "炭素", "窒素", "酸素", "フッ素", "ネオン", "ナトリウム", "マグネシウム", "アルミニウム", "ケイ素", "リン", "硫黄", "塩素", "アルゴン", "カリウム", "カルシウム", "スカンジウム",
		"チタン", "バナジウム", "クロム", "マンガン", "鉄", "コバルト", "ニッケル", "銅", "亜鉛", "ガリウム", "ゲルマニウム", "ヒ素", "セレン", "臭素", "クリプトン", "ルビジウム", "ストロンチウム", "イットリウム", "ジルコニウム", "ニオブ", "モリブデン", "テクネチウム", "ルテニウム",
		"ロジウム", "パラジウム", "銀", "カドミウム", "インジウム", "スズ", "アンチモン", "テルル", "ヨウ素", "キセノン", "セシウム", "バリウム", "ランタン", "セリウム", "プラセオジム", "ネオジム", "プロメチウム", "サマリウム", "ユウロビウム", "ガドリニウム", "テルビウム", "ジスプロニウム",
		"ホルミウム", "エルビウム", "ツリウム", "イッテルビウム", "ルテチウム", "ハフニウム", "タンタル", "タングステン", "レニウム", "オスミウム", "イリジウム", "白金", "金", "水銀", "タリウム", "鉛", "ビスマス", "ポロニウム", "アスタチン", "ラドン", "フランシウム", "ラジウム",
		"アクチニウム", "トリウム", "プロトアクチウム", "ウラン", "ネプツニウム", "プルトニウム", "アメリシウム", "キュリウム", "バークリウム", "カルホルニウム", "アインスタイニウム", "フェルミウム", "メンデレビウム", "ノーベリウム", "ローレンシウム", "ラサホージウム", "ドブニウム", "シーボーギウム",
		"ボーリウム", "ハッシウム", "マイトネリウム", "ダームスタチウム", "レントゲニウム", "コペルニシウム", "ウンウントリウム", "ウンウンクアジウム", "ウンウンペンチウム", "ウンウンヘキシウム", "ウンウンセプチウム", "ウンウンオクチウム" };

	/**
	 * このmodのインスタンス
	 */
	@Mod.Instance("chemiCraft")
	public static ChemiCraft instance;

	/**
	 * ChemiCraftのProxy.
	 */
	@SidedProxy(clientSide = "pcc.chemicraft.client.ClientProxy", serverSide = "pcc.chemicraft.system.CommonProxy")
	public static CommonProxy proxy;

	/**
	 * ChemiCraftのCreativeTab.
	 */
	public static final CreativeTabs creativeTabChemiCraft = new CreativeTabChemiCraft("ChemiCraft");
	public static final CreativeTabs creativeTabAtomsOre = new CreativeTabAtomOres("AtomsOre");

	/**
	 * ItemID.
	 */
	public int atomsID;
	public int compoundsID;
	public int gasCollectingBottleID;
	public int atomGrenadeID;
	public int chemicalCellsID;

	/**
	 * BlockID.
	 */
	public int pyrolysisTableID;
	public int electrolysisTableID;
	public int chemicalConbinationTableID;
	public int toolAndWeaponCraftingTableID;
	public int chemicalCraftingTableID;

	public int[] atomOresID = new int[3];

	/**
	 * GUIID.
	 */
	public int guiPyrolysisTableID;
	public int guiElectrolysisTableID;
	public int guiChemicalCombinationTableID;
	public int guiToolAndWeaponCraftingTableID;
	public int guiChemicalCraftingTableID;

	/**
	 * Block型変数.
	 */
	public Block blockPyrolysisTable;
	public Block blockElectrolysisTable;
	public Block blockChemicalCombinationTable;
	public Block blockToolAndWeaponCraftingTable;
	public Block blockChemicalCraftingTable;

	public Block[] blockAtomOres = new Block[atomOresID.length];

	/**
	 * Item型変数.
	 */
	public Item itemAtoms;
	public Item itemCompounds;
	public Item itemGasCollectingBottle;
	public Item itemAtomGrenade;
	public Item itemChemicalCells;

	/**
	 * このmodで使用するTextureのパス.
	 */
	public final String ITEM_ATOMS_TEXTURE = "/pcc/chemicraft/items/Atoms.png";
	public final String ITEM_COMPOUNDS_TEXTURE = "/pcc/chemicraft/items/Compounds.png";
	public final String ITEM_VEGETABLES_TEXTURE = "/pcc/chemicraft/items/Vegetables.png";
	public final String ITEM_TEXTURE = "/pcc/chemicraft/items/items.png";
	public final String BLOCK_CHEMICAL_CRAFTING_TABLE_TEXTURE = "/pcc/chemicraft/blocks/cctable.png";
	public final String BLOCK_ATOMS_ORE_TEXTURE = "/pcc/chemicraft/blocks/AtomsOre.png";
	public final String BLOCK_VEGETABLES_TEXTURE = "/pcc/chemicraft/blocks/Vegetables.png";
	public final String GUI_PYROLYSIS_TEXTURE = "/pcc/chemicraft/guis/Pyrolysis.png";
	public final String GUI_ELECTROLYSIS_TEXTURE = "/pcc/chemicraft/guis/Electrolysis.png";
	public final String GUI_CHEMICALCOMBINATION_TEXTURE = "/pcc/chemicraft/guis/ChemicalCombination.png";
	public final String GUI_TOOLANDWEAPONCRAFTING_TEXTURE = "/pcc/chemicraft/guis/ToolAndWeaponCrafting.png";
	public final String GUI_CHEMICALCRAFTING_TEXTURE = "/pcc/chemicraft/guis/MaterialCrafting.png";

	/**
	 * このmodに必要な補助クラスのインスタンス.
	 */
	public Auxiliary auxiliary = new Auxiliary();
	public NameAuxiliary nameAuxiliary = new NameAuxiliary();
	public ArrayAuxiliary arrayAuxiliary = new ArrayAuxiliary();

	private ChemiCraftAPI api = ChemiCraftAPI.instance();
	private ChemiCraftData chemicalData = new ChemiCraftData();

	/**
	 * このMODのスレッド
	 */
	private Thread thread;

	/**
	 * Eventのインスタンス(PostInit以降)
	 */
	private FMLPostInitializationEvent event;

	@Mod.PreInit
	public void chemiPreLoadMethod(final FMLPreInitializationEvent event) {
		Configuration cfg = new Configuration(event.getSuggestedConfigurationFile());
		cfg.load();

		Property pyrolysisTableIDProp = cfg.getBlock("PyrolysisTable", 2400);
		Property electrolysisTableIDProp = cfg.getBlock("ElectrolysisTable", 2401);
		Property chemicalCombinationTableIDProp = cfg.getBlock("ChemicalCombinationID", 2402);
		Property toolAndWeaponCraftingTableIDProp = cfg.getBlock("ToolAndWeaponCraftingTableID", 2403);
		Property chemicalCraftingTableIDProp = cfg.getBlock("ChemicalCraftingTableID", 2404);

		Property[] atomOresIDProp = new Property[this.atomOresID.length];
		for (int i = 0; i < atomOresIDProp.length; i++) {
			atomOresIDProp[i] = cfg.getBlock("AtomsOreID:" + i, 2500 + i);
		}

		Property atomsIDProp = cfg.getItem("AtomsID", 25000);
		Property compoundsIDProp = cfg.getItem("CompoundsID", 25001);
		Property gasCollectingBottleIDProp = cfg.getItem("gasCollectingBottleID", 25002);
		Property atomGrenadeIDProp = cfg.getItem("AtomGrenadeID", 25003);
		Property chemicalCellsIDProp = cfg.getItem("ChemicalCellID", 25004);

		Property guiPyrolysisTableIDProp = cfg.get("GUI", "GUIPyrolysisID", 1000);
		Property guiElectrolysisTableIDProp = cfg.get("GUI", "GUIElectrolysisTableIDProp", 1001);
		Property guiChemicalCombinationTableIDProp = cfg.get("GUI", "GUIChemicalCombinationTableID", 1002);
		Property guiToolAndWeaponCraftingTableIDProp = cfg.get("GUI", "GUIToolAndWeaponCraftingTableID", 1003);
		Property guiChemicalCraftingTableIDProp = cfg.get("GUI", "GUIChemicalCraftingTableID", 1004);


		this.pyrolysisTableID = pyrolysisTableIDProp.getInt();
		this.electrolysisTableID = electrolysisTableIDProp.getInt();
		this.chemicalConbinationTableID = chemicalCombinationTableIDProp.getInt();
		this.toolAndWeaponCraftingTableID = toolAndWeaponCraftingTableIDProp.getInt();
		this.chemicalCraftingTableID = chemicalCraftingTableIDProp.getInt();
		for (int i = 0; i < atomOresID.length; i++) {
			this.atomOresID[i] = atomOresIDProp[i].getInt();
		}

		this.atomsID = atomsIDProp.getInt();
		this.compoundsID = compoundsIDProp.getInt();
		this.gasCollectingBottleID = gasCollectingBottleIDProp.getInt();
		this.atomGrenadeID = atomGrenadeIDProp.getInt();
		this.chemicalCellsID = chemicalCellsIDProp.getInt();

		this.guiPyrolysisTableID = guiPyrolysisTableIDProp.getInt();
		this.guiElectrolysisTableID = guiElectrolysisTableIDProp.getInt();
		this.guiChemicalCombinationTableID = guiChemicalCombinationTableIDProp.getInt();
		this.guiToolAndWeaponCraftingTableID = guiToolAndWeaponCraftingTableIDProp.getInt();
		this.guiChemicalCraftingTableID = guiChemicalCraftingTableIDProp.getInt();

		cfg.save();
	}

	@Mod.ServerStarting
	public void serverStarting(final FMLServerStartingEvent event) {
		event.registerServerCommand(new CommandSetTile());
		event.registerServerCommand(new CommandDeleteItem());
		event.registerServerCommand(new CommandGenDebugRoom());
	}

	@Mod.PostInit
	public void chemiPostLoadMethod(final FMLPostInitializationEvent event) {
		this.thread = new Thread(this);
		this.event = event;
		try {
			Thread.sleep(5000);
		} catch (InterruptedException e1) {
			e1.printStackTrace();
		}
		this.thread.start();
		try {
			this.thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		proxy.registerRenderInformation();
		Thread.yield();
	}

	@Override
	public void run() {
		while (true) {
			if (proxy != null && instance != null) {
				this.settingProcessing(event);
				this.apiProcessing(event);
				this.debug(event);
				break;
			}
		}
	}

	private void settingProcessing(final FMLPostInitializationEvent event) {

		// Blockを追加します
		this.blockPyrolysisTable = new BlockPyrolysisTable(this.pyrolysisTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("PyrolysisTable");
		this.blockElectrolysisTable = new BlockElectrolysisTable(this.electrolysisTableID, 1, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ElectrolysisTable");
		this.blockChemicalCombinationTable = new BlockChemicalCombinationTable(this.chemicalConbinationTableID, 2, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ChemicalCombinationTable");
		this.blockToolAndWeaponCraftingTable = new BlockToolAndWeaponCraftingTable(this.toolAndWeaponCraftingTableID, 3, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ToolAndWeaponCraftingTable");
		this.blockChemicalCraftingTable = new BlockChemicalCraftingTable(this.chemicalCraftingTableID, 4, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ChemicalCraftingTable");

		for (int i = 0; i < blockAtomOres.length; i++)
		{
			this.blockAtomOres[i] = new BlockAtomOres(this.atomOresID[i]).
					setHardness(3.0F).
					setResistance(0.0F).
					setStepSound(Block.soundStoneFootstep).
					setBlockName("AtomsOre" + i);
			GameRegistry.registerBlock(blockAtomOres[i], ItemAtomOres.class, "AtomsOre" + i);
		}

		// Itemを追加します
		this.itemAtoms = new ItemAtoms(this.atomsID).setItemName("atoms");
		this.itemCompounds = new ItemCompounds(this.compoundsID).setItemName("compounds");
		this.itemGasCollectingBottle = new ItemGasCollectingBottle(this.gasCollectingBottleID).setItemName("gasCollectingBottle").setIconIndex(0);
		this.itemAtomGrenade = new ItemAtomsGrenade(this.atomGrenadeID).setItemName("grenade").setIconIndex(1);
		this.itemChemicalCells = new ItemChemiCell(this.chemicalCellsID).setItemName("chemiCell").setIconIndex(3);

		// BlockをMinecraftに登録します
		GameRegistry.registerBlock(this.blockPyrolysisTable, "BlockPyrolysisTable");
		GameRegistry.registerBlock(this.blockChemicalCombinationTable, "BlockChemicalCombinationTable");
		GameRegistry.registerBlock(this.blockToolAndWeaponCraftingTable, "BlockToolAndWeaponCraftingTable");
		GameRegistry.registerBlock(this.blockChemicalCraftingTable, "BlockMaterialCraftingTable");
		GameRegistry.registerBlock(this.blockElectrolysisTable, "BlockElectrolysisTable");

		// Blockの名前を設定します
		this.nameAuxiliary.addName(this.blockPyrolysisTable, "PyrolysisTable");
		this.nameAuxiliary.addName(this.blockPyrolysisTable, "ja_JP", "熱分解台");
		this.nameAuxiliary.addName(this.blockChemicalCombinationTable, "ChemicalCombinationTable");
		this.nameAuxiliary.addName(this.blockChemicalCombinationTable, "ja_JP", "化合台");
		this.nameAuxiliary.addName(this.blockToolAndWeaponCraftingTable, "ToolAndWeaponCraftingTable");
		this.nameAuxiliary.addName(this.blockToolAndWeaponCraftingTable, "ja_JP", "ツール&武器製作台");
		this.nameAuxiliary.addName(this.blockChemicalCraftingTable, "ChemicalCraftingTable");
		this.nameAuxiliary.addName(this.blockChemicalCraftingTable, "ja_JP", "素材製作台");
		this.nameAuxiliary.addName(this.blockElectrolysisTable, "ElectrolysisTable");
		this.nameAuxiliary.addName(this.blockElectrolysisTable, "ja_JP", "電気分解台");

		// Itemの名前を設定します
		this.nameAuxiliary.addName(this.itemAtoms, ATOMSNAME);
		this.nameAuxiliary.addName(this.itemAtoms, "ja_JP", ATOMSNAMEJP);
		this.nameAuxiliary.addName(this.itemGasCollectingBottle, "GasCollectingBottle");
		this.nameAuxiliary.addName(this.itemGasCollectingBottle, "ja_JP", "集気瓶");
		this.nameAuxiliary.addName(this.itemAtomGrenade, "AtomGrenade");
		this.nameAuxiliary.addName(this.itemAtomGrenade, "ja_JP", "元素手榴弾");

		// TileEntityを追加します
		GameRegistry.registerTileEntity(TileEntityPyrolysisTable.class, "TileEntityPyrolysisTable");
		GameRegistry.registerTileEntity(TileEntityChemicalCombinationTable.class, "TileEntityChemicalCombinationTable");
		GameRegistry.registerTileEntity(TileEntityToolAndWeaponCraftingTable.class, "TileEntityToolAndWeaponCraftingTable");
		GameRegistry.registerTileEntity(TileEntityChemicalCraftingTable.class, "TileEntityChemicalCraftingTable");
		GameRegistry.registerTileEntity(TileEntityElectrolysisTable.class, "TileEntityElectrolysisTable");

		// GUIを追加します
		NetworkRegistry.instance().registerGuiHandler(instance, proxy);

		//化学作業台類のレシピを追加します
		GameRegistry.addRecipe(new ItemStack(this.blockPyrolysisTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Item.bucketLava),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockChemicalCombinationTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Block.obsidian),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockToolAndWeaponCraftingTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Item.pickaxeSteel),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockChemicalCraftingTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(this.itemAtoms, 1, 0),
		});

		//電池を追加します
		api.addChemicalCell(itemChemicalCells, "ChemicalCell", 1000);
		api.addChemicalCellLanguage("ChemicalCell", "ja_JP", "化学電池");

		//鉱石を追加します

		// リチウム
		api.addAtomOres("Petalite", new String[]{"Li", "Al", "Si", "O"}, new Integer[]{1, 1, 4, 10}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // LiAlSi4O10
		api.addAtomOresLanguage("Petalite", "ペタル石", "ja_JP");
		api.addAtomOres("Spodumene", new String[]{"Li", "Al", "Si", "O"}, new Integer[]{1, 1, 2, 6}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // LiAlSi2O6
		api.addAtomOresLanguage("Spodumene", "リチア輝石", "ja_JP");

		// ベリリウム
		api.addAtomOres("Beryl", new String[]{"Be", "Al", "Si", "O"}, new Integer[]{3, 2, 6, 18}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Be3Al2Si6O18
		api.addAtomOresLanguage("Beryl", "緑柱石", "ja_JP");
		api.addAtomOres("Chrysoberyl", new String[]{"Be", "Al", "O"}, new Integer[]{1, 2, 4}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // BeAl2O4
		api.addAtomOresLanguage("Chrysoberyl", "金緑石", "ja_JP");

		// ホウ素
		api.addAtomOres("Ulexite", new String[]{"Na", "Ca", "B", "O", "H"}, new Integer[]{1, 1, 5, 17, 16}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50);   // NaCaB5O6(OH)6・5H2O
		api.addAtomOresLanguage("Ulexite", "ウレキサイト", "ja_JP");

		// フッ素
		api.addAtomOres("Fluorite", new String[]{"Ca", "F"}, new Integer[]{1, 2}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // CaF2
		api.addAtomOresLanguage("Fluorite", "蛍石", "ja_JP");
		api.addAtomOres("Cryolite", new String[]{"Na", "Al", "F"}, new Integer[]{3, 1, 6}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Na3AlF6
		api.addAtomOresLanguage("Cryolite", "氷晶石", "ja_JP");

		// ナトリウム
		api.addAtomOres("RockSalt", new String[]{"Na", "Cl"}, new Integer[]{1, 1}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // NaCl
		api.addAtomOresLanguage("RockSalt", "岩塩", "ja_JP");

		// マグネシウム
		api.addAtomOres("Dolomite", new String[]{"Ca", "Mg", "C", "O"}, new Integer[]{1, 1, 2, 6}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // CaMg(CO3)2
		api.addAtomOresLanguage("Dolomite", "苦灰石", "ja_JP");
		api.addAtomOres("Magnesite", new String[]{"Mg", "C", "O"}, new Integer[]{1, 1, 3}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // MgCO3
		api.addAtomOresLanguage("Magnesite", "菱苦土石", "ja_JP");

		// アルミニウム
		api.addAtomOres("Gibbsite", new String[]{"Al", "O", "H"}, new Integer[]{3, 3, 3}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Al(OH)3
		api.addAtomOresLanguage("Gibbsite", "ギブス石", "ja_JP");
		api.addAtomOres("Ruby", new String[]{"Al", "O"}, new Integer[]{2, 3}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Al2O3
		api.addAtomOresLanguage("Ruby", "ルビー", "ja_JP");
		api.addAtomOres("Sapphire", new String[]{"Al", "O"}, new Integer[]{2, 3}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Al2O3
		api.addAtomOresLanguage("Sapphire", "サファイア", "ja_JP");

		// ケイ素
		api.addAtomOres("Quartz", new String[]{"Si", "O"}, new Integer[]{1, 2}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // SiO2
		api.addAtomOresLanguage("Quartz", "石英", "ja_JP");

		// リン
		api.addAtomOres("Fluorapatite", new String[]{"Ca", "P", "O", "F"}, new Integer[]{5, 3, 12, 1}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Ca5(PO4)3F
		api.addAtomOresLanguage("Fluorapatite", "フッ素リン灰石", "ja_JP");
		api.addAtomOres("Chlorapatite", new String[]{"Ca", "P", "O", "Cl"}, new Integer[]{5, 3, 12, 1}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Ca5(PO4)3Cl
		api.addAtomOresLanguage("Chlorapatite", "塩素燐灰石", "ja_JP");
		api.addAtomOres("Hydroxylapatite", new String[]{"Ca", "P", "O", "H"}, new Integer[]{5, 3, 13, 1}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // Ca5(PO4)3(OH)
		api.addAtomOresLanguage("Hydroxylapatite", "水酸燐灰石", "ja_JP");

		// カリウム
		api.addAtomOres("Sylvite", new String[]{"K", "Cl"}, new Integer[]{1, 1}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // KCl
		api.addAtomOresLanguage("Sylvite", "カリ岩塩", "ja_JP");

		// カルシウム
		api.addAtomOres("Calcite", new String[]{"Ca", "C", "O"}, new Integer[]{1, 1, 3}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // CaCO3
		api.addAtomOresLanguage("Calcite", "方解石", "ja_JP");

		// スカンジウム
		api.addAtomOres("Thortveitite", new String[]{"Sc", "Y", "Si", "O"}, new Integer[]{2, 2, 2, 7}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // (Sc,Y)2Si2O7
		api.addAtomOresLanguage("Thortveitite", "トルトベイト石", "ja_JP");

		// api.addAtomOres("元素名(英)", new String[]{"元素"}, new Integer[]{<数>}, this.atomOresID[api.getAtomOresLastIndex()], 5, 1, 50); // 化学式
		// api.addAtomOresLanguage("元素名(英)", "元素名(他国語)", "言語");

		//化合物を追加します
		this.api.addCompound("ja_JP", "ChlorousAcid", "亜塩素酸");
		this.api.addCompound("ja_JP", "CarbonMonoxide", "一酸化炭素");
		this.api.addCompound("ja_JP", "CarbonDioxide", "二酸化炭素");
		this.api.addCompound("ja_JP", "Water", "水");
		this.api.addCompound("ja_JP", "SodiumChloride", "塩化ナトリウム");
		this.api.addCompound("ja_JP", "SodiumBicarbonate", "重曹");

		//化合物のHandlerを設定します
		this.api.settingCompoundHandler("Water", new CompoundWater());

		//化合物のレシピを追加します
		this.api.addChemicalCombinationRecipe(new String[]{"Na", "O", "H"}, new Integer[]{1, 1, 1}, new ItemStack(this.itemCompounds, 1, this.api.getCompound("SodiumChloride")));
		this.api.addChemicalCombinationRecipe(new String[]{"H", "O", "Cl"}, new Integer[]{1, 2, 1}, new ItemStack(this.itemCompounds, 1, this.api.getCompound("ChlorousAcid")));
		this.api.addChemicalCombinationRecipe(new String[]{"H", "O"}, new Integer[]{2, 1}, new ItemStack(this.itemCompounds, 1, this.api.getCompound("Water")));

		//化学電池の追加
		this.api.addMaterialRecipe(new ItemStack[] {
				null,
				null,
				null,
				new ItemStack(this.itemAtoms, 1, ChemiCraftData.ZINC),
				null,
				new ItemStack(this.itemAtoms, 1, ChemiCraftData.COPPER),
				new ItemStack(Item.bucketWater),
				new ItemStack(Item.bucketWater),
				new ItemStack(Item.bucketWater),
		},
		new ItemStack(this.itemChemicalCells, 1, 0),
		null);

		//手榴弾の追加
		this.api.addMaterialRecipe(new ItemStack[] {
				null,
				new ItemStack(Block.stone),
				null,
				new ItemStack(Block.stone),
				new ItemStack(Item.gunpowder),
				new ItemStack(Block.stone),
				null,
				new ItemStack(Block.stone),
				null
		},
		new ItemStack(this.itemAtomGrenade, 16, 0),
		new NBTRecipeGrenade()
				);

		this.api.addPyrolysisDecompositionRecipe(new ItemStack(Item.potion, 1, 0),
				new Integer[] {ChemiCraftData.HYDROGEN, ChemiCraftData.OXYGEN},
				new Integer[] {2, 1});

		this.api.addPyrolysisDecompositionRecipe(new ItemStack(this.itemCompounds, 1, this.api.getCompound("Water")),
				new Integer[] {ChemiCraftData.HYDROGEN, ChemiCraftData.OXYGEN},
				new Integer[] {2, 1});

		for (int i = 0; i < api.getAtomOresName().sizeKeysList(); i++){
			this.api.addPyrolysisDecompositionRecipe(new ItemStack(this.blockAtomOres[i / 16], 1, i - i / 16 * 16),
					api.getAtomOresAtoms().get(api.getAtomOresName().getKeyList(i)),
					api.getAtomOresAmounts().get(api.getAtomOresName().getKeyList(i)));
		}

		this.api.addPyrolysisDecompositionFuel(new ItemStack(Item.coal), 2000*8);
	}

	private void apiProcessing(final FMLPostInitializationEvent event) {
		// API用の処理
		for (int i = 0; i < api.getAtomOresName().sizeKeysList(); i++)
		{
			for (int j = 0; j < api.getAtomOresName().sizeElementsList(api.getAtomOresName().getKeyList(i)); j++)
			{
				this.nameAuxiliary.addName(new ItemStack(blockAtomOres[i / 16], 0, i - i / 16 * 16), api.getAtomOresLanguage().get(api.getAtomOresName().getKeyList(i), j), api.getAtomOresName().get(api.getAtomOresName().getKeyList(i), j));
				OreDictionary.registerOre("ore" + api.getAtomOresName().getKeyList(i), new ItemStack(blockAtomOres[i / 16], 1, i - i / 16 * 16));
			}
		}

		for (int i = 0; i < api.getAtomOres().size(); i++)
		{
			GameRegistry.registerWorldGenerator(api.getAtomOres().get(i));
		}

		for (int i = 0; i < api.getChemicalCellsName().sizeKeysList(); i++)
		{
			for (int j = 0; j < api.getChemicalCellsName().sizeElementsList(api.getChemicalCellsName().getKeyList(i)); j++)
			{
				this.nameAuxiliary.addName(new ItemStack(itemChemicalCells, 0, i), api.getChemicalCellsLanguage().get(api.getChemicalCellsName().getKeyList(i), j), api.getChemicalCellsName().get(api.getChemicalCellsName().getKeyList(i), j));
			}
		}

		for (int i = 0; i < api.getCompoundsName().sizeKeysList(); i++)
		{
			for (int j = 0; j < api.getCompoundsName().sizeElementsList(api.getCompoundsName().getKeyList(i)); j++)
			{
				this.nameAuxiliary.addName(new ItemStack(itemCompounds, 0, i), api.getCompoundsLang().get(api.getCompoundsName().getKeyList(i), j), api.getCompoundsName().get(api.getCompoundsName().getKeyList(i), j));
			}
		}

	}

	private void debug(final FMLPostInitializationEvent event) {
		this.proxy.registerTickHandler();
		this.api.addCompound("Debug");
		this.api.settingCompoundHandler("Debug", new CompoundDebug());

		this.api.addToolAndWeaponRecipe(new ItemStack[] {
				new ItemStack(Block.stone, 1, 1)
		},
		new ItemStack(Block.dirt, 1, 0));

	}

}
